#include <iostream>

// ͼνӿ
class Shape {
public:
	virtual void Draw() = 0;
	virtual int GetX() const = 0;
	virtual int GetY() const = 0;
	virtual ~Shape() = default;
};

// ľ
class Rectangle {
public:
	Rectangle(int x, int y) : x_(x), y_(y) {}
	void DrawShape() {
		std::cout << "Drawing rectangle at (" << x_ << ", " << y_ << ")\n";
	}
	int GetXCoordinate() const { return x_; }
	int GetYCoordinate() const { return y_; }
private:
	int x_, y_;
};

// ģ
template <typename T>
class ShapeAdapter : public Shape {
public:
	ShapeAdapter(T* adaptee) : adaptee_(adaptee) {}
	void Draw() override {
		adaptee_->DrawShape();
	}
	int GetX() const override {
		return adaptee_->GetXCoordinate();
	}
	int GetY() const override {
		return adaptee_->GetYCoordinate();
	}
private:
	T* adaptee_;
};

int main() {
	Rectangle* rectangle = new Rectangle(10, 20);
	Shape* shape = new ShapeAdapter<Rectangle>(rectangle);
	shape->Draw();
	std::cout << "X: " << shape->GetX() << ", Y: " << shape->GetY() << '\n';
	delete shape;
	delete rectangle;
	return 0;
}