#include <iostream>
#include <string>

// Ʒ
class Product
{
public:
	Product(const std::string& name, int price) : m_name(name), m_price(price) {}
	std::string GetName() const { return m_name; }
	int GetPrice() const { return m_price; }

private:
	std::string m_name;
	int m_price;
};

// ߽ӿ
class Builder
{
public:
	virtual ~Builder() {}
	virtual void SetName(const std::string& name) = 0;
	virtual void SetPrice(int price) = 0;
	virtual Product* GetProduct() = 0;
};

// 彨
class ConcreteBuilder : public Builder
{
public:
	ConcreteBuilder() : m_product(nullptr) {}
	void SetName(const std::string& name) override { m_product = new Product(name, 0); }
	void SetPrice(int price) override { m_product->m_price = price; }
	Product* GetProduct() override { return m_product; }

private:
	Product* m_product;
};

// 
class Director
{
public:
	Director(Builder* builder) : m_builder(builder) {}
	void Construct(const std::string& name, int price)
	{
		m_builder->SetName(name);
		m_builder->SetPrice(price);
	}

private:
	Builder* m_builder;
};

int main()
{
	// 彨߶
	ConcreteBuilder builder;
	// ݶ
	Director director(&builder);
	// õݵĹƷ
	director.Construct("Product A", 100);
	// ȡƷ
	Product* product = builder.GetProduct();
	std::cout << "Name: " << product->GetName() << std::endl;
	std::cout << "Price: " << product->GetPrice() << std::endl;

	return 0;
}
