#include <stdio.h>
#include <stdlib.h>

// 
typedef enum {
	OPERATION_ADD,
	OPERATION_SUB,
	OPERATION_MUL,
	OPERATION_DIV
} OperationType;

// 㺯ָ
typedef double(*OperationFunc)(double, double);

// ӷ
double Add(double a, double b)
{
	return a + b;
}

// 
double Sub(double a, double b)
{
	return a - b;
}

// ˷
double Mul(double a, double b)
{
	return a * b;
}

// 
double Div(double a, double b)
{
	if (b == 0) {
		printf("Error: division by zero.\n");
		exit(EXIT_FAILURE);
	}
	return a / b;
}

// 
OperationFunc CreateOperation(OperationType type)
{
	switch (type) {
	case OPERATION_ADD:
		return Add;
	case OPERATION_SUB:
		return Sub;
	case OPERATION_MUL:
		return Mul;
	case OPERATION_DIV:
		return Div;
	default:
		return NULL;
	}
}

int main()
{
	// ӷ
	OperationFunc op1 = CreateOperation(OPERATION_ADD);
	printf("%.2f + %.2f = %.2f\n", 1.0, 2.0, op1(1.0, 2.0));

	// 
	OperationFunc op2 = CreateOperation(OPERATION_SUB);
	printf("%.2f - %.2f = %.2f\n", 1.0, 2.0, op2(1.0, 2.0));

	// ˷
	OperationFunc op3 = CreateOperation(OPERATION_MUL);
	printf("%.2f * %.2f = %.2f\n", 1.0, 2.0, op3(1.0, 2.0));

	// 
	OperationFunc op4 = CreateOperation(OPERATION_DIV);
	printf("%.2f / %.2f = %.2f\n", 1.0, 2.0, op4(1.0, 2.0));

	return 0;
}
