#include <iostream>
#include <string>

// ͼνӿ
class Shape
{
public:
	virtual ~Shape() {}
	virtual std::string GetType() const = 0;
};

// 
class Rectangle : public Shape
{
public:
	std::string GetType() const override { return "Rectangle"; }
};

// Բ
class Circle : public Shape
{
public:
	std::string GetType() const override { return "Circle"; }
};

// 
class Triangle : public Shape
{
public:
	std::string GetType() const override { return "Triangle"; }
};

// 
// 
class ShapeFactory
{
public:
	static Shape* CreateShape(const std::string& type)
	{
		if (type == "Rectangle")
			return new Rectangle();
		else if (type == "Circle")
			return new Circle();
		else if (type == "Triangle")
			return new Triangle();
		else
			return nullptr;
	}
};

int main()
{
	Shape* shape1 = ShapeFactory::CreateShape("Rectangle");
	std::cout << shape1->GetType() << std::endl;

	Shape* shape2 = ShapeFactory::CreateShape("Circle");
	std::cout << shape2->GetType() << std::endl;

	Shape* shape3 = ShapeFactory::CreateShape("Triangle");
	std::cout << shape3->GetType() << std::endl;

	return 0;
}
