//template factory class
#include <iostream>

// Ʒ
class Product
{
public:
	virtual void Print() = 0;  // 
};

// Ʒ
class ProductA : public Product
{
public:
	virtual void Print()
	{
		std::cout << "I am ProductA." << std::endl;
	}
};

class ProductB : public Product
{
public:
	virtual void Print()
	{
		std::cout << "I am ProductB." << std::endl;
	}
};

// 󹤳
template <typename T>
class Factory
{
public:
	virtual T* CreateProduct() = 0;  // 
};

// 幤
template <typename T>
class ConcreteFactory : public Factory<T>
{
public:
	virtual T* CreateProduct()
	{
		return new T();
	}
};

int main()
{
	// A
	Factory<ProductA>* factoryA = new ConcreteFactory<ProductA>();
	// ʹùAƷA
	ProductA* productA = factoryA->CreateProduct();
	productA->Print();  //  "I am ProductA."

	// B
	Factory<ProductB>* factoryB = new ConcreteFactory<ProductB>();
	// ʹùBƷB
	ProductB* productB = factoryB->CreateProduct();
	productB->Print();  //  "I am ProductB."

	return 0;
}
